﻿using UnityEngine;
using System.Collections;

public class TrapDestroyer : MonoBehaviour
{
  public float respawnTime = 5.0f;
  private Vector2 realPosition;
  private AudioSource audio;

  void Start()
  {
    audio = GetComponent<AudioSource>();
  }

  void OnTriggerEnter2D(Collider2D other)
  {
    if (other.tag == "Player")
    {
      GameObject bestTrap = null;
      float bestDistance = float.PositiveInfinity;
      GameObject[] traps = GameObject.FindGameObjectsWithTag("Trap");
      foreach (GameObject player in GameObject.FindGameObjectsWithTag("Player"))
      {
        if (player == other.gameObject)
          continue;

        foreach (GameObject trap in traps)
        {
          float distance = (player.transform.position - trap.transform.position).magnitude;
          if (distance < bestDistance)
          {
            bestTrap = trap;
            bestDistance = distance;
          }
        }

        if (bestTrap != null)
        {
          bestTrap.GetComponent<Trap>().destroyTrapWithEffect();
          if(audio)audio.Play();
        }
      }

      DestroyPowerUp();
    }
  }

  void DestroyPowerUp()
  {
    realPosition = transform.position;
    transform.position = new Vector2(1000, 1000);
    Invoke("Activate", respawnTime);
  }

  void Activate()
  {
    transform.position = realPosition;
  }
}
